;Cube Conquest (Working Title)
;------------------------------------------------------
;$Id: cubeconq.s,v 1.1.2.2 2002/08/14 02:25:56 Billy Exp $
;------------------------------------------------------
	processor 6502
    include "vcs.h"
;color defines
GRAY		=	$00
GOLD		=	$10
ORANGE		=	$20
BRT_ORANGE	=	$30
PINK		=	$40
PURPLE		=	$50
PURPLE_BLUE	=	$70
BLUE		=	$80
GREEN		=	$C0
LT_ORANGE	=	$F0

LUM1		= 	$00	
LUM2		=	$02
LUM3		= 	$04	
LUM4		= 	$06	
LUM5		= 	$08	
LUM6		= 	$0a	
LUM7		= 	$0c	
LUM8		=	$0e

LIGHTGRAY	=	GRAY | LUM3
BLACK		= 	GRAY | LUM1
WHITE		=	$FF

P0COLOR		=	BRT_ORANGE | LUM4
P1COLOR		=	GREEN | LUM4

;missile size defines
MISS_1CLK	=	$00
MISS_2CLK	=	$10
MISS_4CLK	=	$20
MISS_8CLK	=	$30

BLANKCOLOR	=	GRAY | LUM6
BACKGROUND	= 	GRAY | LUM2

;playing field defines
PFHEIGHT	=	16
PFWIDTH		=	16

;Ram variables.....

	        SEG.U   variables

;play field looks like this
;  |leftpf1 |leftpf2 |rightpf2|rightpf1| 
;--+--------+--------+--------+--------+
;  |76543210|01233457|76543210|01234567|
;--+--------+--------+--------+--------+
;\X|        |  111111|11112222|22222233|
;Y\|01234567|89012345|67890123|45678901|
;--+--------+--------+--------+--------+
;22| 
; ||
; 0|
	     	org $80
Playfield
leftpf		ds 	16			;pf2 part of display (16 lines)
rightpf		ds 	16			;pf2 part of display (16 lines)

leftp0		ds	16
rightp0		ds	16

leftp1		ds	16
rightp1		ds	16


rand0		ds	1			;16 bit random number
rand1		ds	1

innercnt	ds	1			;used to draw the screen
outercnt	ds	1		

framenum	ds	1

temp0		ds	1
temp1		ds	1
temp2		ds	1
temp3		ds	1

	SEG code

	org	$f000
;	include "macros.s"				;some macros
;	include "move_player_macro.s"	;player move macro
;	include "wrap_move_player_macro.s"	;wrap mode player move macro
	include "fielddraw.s"			;fielddraw clear_playfield subroutine
	include "common.s"				;common subs
;	include	"FC_position.s"
;	include "joystick.s"			;joystick subs


;Setup stuff
start
	sei             ;clear interupts
	cld             ;set to non-BCD mode

    
;Clear all memory except $ff/$1ff - Stack end
	lda #0
clear
	sta $ff,x		;x still has $ff in it
	dex
	bne clear		;x comes out with 0

;set up playfield mirroring
	lda	#1
	sta	CTRLPF	;set playfield to mirror

	
main_game
;	lda	#30
;	sta	framenum
	
normal_repeat				;repeat point

	jsr	clear_playfield		;clear the playfield

;load up playfield
	lda	#$00
	
	jsr load_playfield
	

;set player numbers to 0
	lda	#0
	sta	NUSIZ0
	sta	NUSIZ1

;setup the missiles
	lda	#$02
	sta	RESMP0		;lock the missiles to the players (and disable)
	sta	RESMP1

;Draw the frame
;set the playfield color
	lda	#BLANKCOLOR
	sta	COLUPF

frame
;Vertical sync
	jsr start_vertical_sync

;wait for the vertical blank to end
	jsr wait_timer
	sta	WSYNC
	sta	VBLANK   ;A comes back as zero, end vblank
	
;put a color border around the play field	
	sta WSYNC
	sta WSYNC
;	lda	#SNAKECOLOR
;	sta	COLUBK
;use pf0 to make the left and right outline
;	lda	#$FF
;	sta	PF0		;make an outline

	lda	#8			;518 clocks, 8 tim64s, 7 lines
	sta	TIM64T

	jsr wait_timer	;wait for the timer to end

;set the background	
	sta	WSYNC		
	lda	#BLACK
	sta	COLUBK		

;8 lines
	ldy	32
	jsr wait_lines
;40 lines

	;set up the counts so the subroutine knows how many lines to draw
	lda #PFHEIGHT-1
	sta	outercnt

;	dec	framenum
;	lda framenum
;	cmp	#15
;	bmi	draw_field_blocks
	
	jsr	playerfielddraw		;112 lines
;152 lines
;	jmp done_fielddraw

;draw_field_blocks
;	jsr fielddraw
;	lda framenum
;	bne	no_reset_framenum
;	lda	#30
;	sta	framenum
;no_reset_framenum
;done_fielddraw
	;a is 0 coming out of the subroutine
	sta	ENAM0
	sta	ENAM1

;wait one more line, then change the background to make the border
	sta	WSYNC
;	lda	#SNAKECOLOR
;	sta	COLUBK

;put a color border around the play field	
	lda	#8			;8 tim64s, 7 lines
	sta	TIM64T
;159 lines
	jsr wait_timer

	sta	WSYNC	
	lda #0
	sta	COLUBK		;set back to black
;	sta	PF0			;clear outline

	ldy	33
	jsr wait_lines
;192 lines
;draw the digits of the score
	

;Overscan
	jsr start_Overscan	

;check for reset
	lda SWCHB
	and	#1
	bne	no_reset
reset
	jmp	main_game
no_reset

	jmp	frame_done

frame_done

;wait for overscan to end	
wait_FF
	lda INTIM		;timer ended?
	bne	wait_FF

	jmp frame

;this packs graphics.c and drawit.s all the way down to the bottom, where all should work	
	org	$fcf1		
	include "graphics.s"
;	include "drawit.s"
;make sure nothing gets put here so unmodified superchargers 
;can play the game
	org	$fff8
	ds	4
;Boot up points....

	org	$fffc
	dc.w	start                    ; Reset vector
    dc.w	start                    ; IRQ vector

;------------------------------------------------------
;$Log: cubeconq.s,v $
;Revision 1.1.2.2  2002/08/14 02:25:56  Billy
;experiment with changing background color
;
;Revision 1.1.2.1  2002/08/14 01:11:49  Billy
;Playfield experiments
;
;------------------------------------------------------
